summaryrefslogtreecommitdiff
path: root/CREDITS-GEN
diff options
context:
space:
mode:
authorLibravatar Shawn O. Pearce <spearce@spearce.org>2007-02-18 21:06:48 -0500
committerLibravatar Shawn O. Pearce <spearce@spearce.org>2007-02-21 00:11:01 -0500
commit871f4c97ad7e021d1a0a98c80c5da77fcf70e4af (patch)
tree599a883816d8ca81177e46e7b476a57078b89a9a /CREDITS-GEN
parentgit-gui: Use mixed path for docs on Cygwin. (diff)
downloadtgif-871f4c97ad7e021d1a0a98c80c5da77fcf70e4af.tar.xz
git-gui: Display all authors of git-gui.
Now that git-gui has been released to the public as part of Git 1.5.0 I am starting to see some work from other people beyond myself and Paul. Consequently the copyright for git-gui is not strictly the two of us anymore, and these others deserve to have some credit given to them. Signed-off-by: Shawn O. Pearce <spearce@spearce.org>
Diffstat (limited to 'CREDITS-GEN')
-rwxr-xr-xCREDITS-GEN58
1 files changed, 58 insertions, 0 deletions
diff --git a/CREDITS-GEN b/CREDITS-GEN
new file mode 100755
index 0000000000..da2c07629e
--- /dev/null
+++ b/CREDITS-GEN
@@ -0,0 +1,58 @@
+#!/bin/sh
+
+CF=CREDITS-FILE
+tip=
+
+tree_search ()
+{
+ head=$1
+ tree=$2
+ for p in $(git rev-list --parents --max-count=1 $head 2>/dev/null)
+ do
+ test $tree = $(git rev-parse $p^{tree} 2>/dev/null) &&
+ vn=$(git describe --abbrev=4 $p 2>/dev/null) &&
+ case "$vn" in
+ gitgui-[0-9]*) echo $p; break;;
+ esac
+ done
+}
+
+generate_credits ()
+{
+ tip=$1 &&
+ rm -f $CF &&
+ git shortlog -n -s $tip | sed 's/: .*$//' >$CF || exit
+}
+
+# Always use the tarball credits file if found, just
+# in case we are somehow contained in a larger git
+# repository that doesn't actually track our state.
+# (At least one package manager is doing this.)
+#
+# We may be a subproject, so try looking for the merge
+# commit that supplied this directory content if we are
+# not at the toplevel. We probably will always be the
+# second parent in the commit, but we shouldn't rely on
+# that fact.
+#
+
+if test -f credits
+then
+ rm -f $CF &&
+ cp credits $CF || exit
+elif prefix="$(git rev-parse --show-prefix 2>/dev/null)" &&
+ test -n "$prefix" &&
+ head=$(git rev-list --max-count=1 HEAD -- . 2>/dev/null) &&
+ tree=$(git rev-parse --verify "HEAD:$prefix" 2>/dev/null) &&
+ tip=$(tree_search $head $tree) &&
+ test -n "$tip"
+then
+ generate_credits $tip || exit
+elif tip="$(git rev-parse --verify HEAD 2>/dev/null)" &&
+ test -n "$tip"
+then
+ generate_credits $tip || exit
+else
+ echo "error: Cannot locate authorship information." >&2
+ exit 1
+fi